function preSimEval( PathName, FileName, save, cc, dd, FdDd, FaAa )

%global data;

%[FileName,PathName] = uigetfile('*.xls','Select an Excel file');
%if isequal(FileName,0)
%   disp('User selected Cancel')
%   return
%else
%   disp(['User selected', fullfile(PathName, FileName)])
%end
global T;
global external_load;

FileNamePlot = '';
fullfile(PathName,FileName)
xls = csvread( fullfile(PathName,FileName) );
ext = csvread( 'external-load.csv' )
external_load=ext;
T = xls(:,1);
T = T / 1000

[mm,nn] = size(xls)
NumberOfCols = ((nn-1)/3)
NumberOfDataCols = NumberOfCols - 1

FRET=2;
CFP = FRET + NumberOfCols;
YFP = FRET + 2*NumberOfCols;

rawdata = xls(:,2:nn);

for j = 1:mm
 k=1;
 for i = 0:NumberOfDataCols-1
  data(j,k) = ( rawdata(j,FRET+i) - FdDd*rawdata(j,CFP+i) - FaAa*rawdata(j,YFP+i) ) / rawdata(j,CFP+i);
  k = k + 1;
 end; 
end;     

[m,n] = size(data)

for i = 1:n
 mini = min( data(:,i) );
 maxi = max( data(:,i) );
 iminmax( i, 1 ) = i;
 iminmax( i, 2 ) = mini; 
 iminmax( i, 3 ) = maxi;
 iminmax( i, 4 ) = data(1,i);
 for j = 1:m
     normdata(j,i) = (data(j,i)/data(1,i) );
 end;
end;
iminmax

for i = 1:n
    k=0;
    for j = (cc+1):m
      if ( ext(j) == 0 )
       if ( ext(j-ceil(cc/2)) == 0 )
        if ( ext(j-cc) == 0 )   
          k=k+1;
          tmpdata(k,i) = normdata(j,i);
          Ttmp(k,i) = T(j);
      end; end; end;
 end;
end;
[m2,n2] = size(tmpdata);


for i = 1:n2
    k=0;
    meann=0;
    meanval=0;
    meant=0;
    for j = 2:m2
        if ((Ttmp(j,i)-Ttmp(j-1,i))>6)
            k=k+1;
            Ttmp2(k,i)=meant/meann;
            tmpdata2(k,i)=meanval/meann;
            meann=0;
            meanval=0;
            meant=0;
        else
            meann=meann+1;
            meanval = meanval+tmpdata(j,i);
            meant = meant + Ttmp(j,i);
        end;
    end;
    k=k+1;
    Ttmp2(k,i)=meant/meann;
    tmpdata2(k,i)=meanval/meann;
    meann=0;
    meanval=0;
    meant=0;
end;

format short e
polydata = [];
for i = 1:n
 p = polyfit( Ttmp2(:,i), tmpdata2(:,i), dd );
 polydata = [polydata; p];
 for j = 1:m
     normdata2(j,i) = (normdata(j,i) - polyval(p,T(j)) +1 );
 end;
end;





%avgdata = mean( data' )';
%normavgdata = mean( normdata' );
%stddata = std( data, 0, 2 );

if save == 2
    FileNameX = strcat( FileName, '-r.csv' );
    FileNameY = strcat( FileName, '-p.csv' );
    %T = T *60 %floor(T)*60 + (t*100-floor(T));
    csvwrite( fullfile(PathName,FileNameX), [T normdata2] );
    csvwrite( fullfile(PathName,FileNameY), polydata );
else

if save == 0 
    h = figure;
    subplot(2,2,1);
    box on;
    plot( T, data );
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
    title('Fig.1: raw ratio data');
    hold on
else
    h = figure;
    box on;
    set(h,'Visible','off')
    plot( T, data );
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
    title('Fig.1: raw ratio data');
    hold on
    FileNamePlot = strcat( FileName, '-r-raw.png' );
    print( h, '-dpng',fullfile(PathName,FileNamePlot) )
end

if save == 0
    subplot(2,2,4);
    box on;
    
    for i=1:mm
      if get_G_out(T(i))==0
        exttmp(i) = 1.1;
        testtext=1;
      else
        if testtext==1
          text( T(i), 1.08, num2str( get_G_out(T(i))) );
          testtext=0;
        end;
        exttmp(i) = 1.1 - 0.01 ;
      end;
    end;        
    
    hold on
    plot( T, normdata2 );
    plot( T, exttmp )
    title('Fig.4: after baseline correction');
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
else
    h = figure
    box on;
    hold on;
    for i=1:mm
      if get_G_out(T(i))==0
        exttmp(i) = 1.1;
        testtext=1;
      else
        if testtext==1
          text( T(i), 1.08, num2str( get_G_out(T(i))) );
          testtext=0;
        end;
        exttmp(i) = 1.1 - 0.01 ;
      end;
    end;     
    set(h,'Visible','off')
    plot( T, normdata2 );
    plot( T, exttmp )    
    title('Fig.4: after baseline correction');
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
    FileNamePlot = strcat( FileName, '-r-final.png' );
    print( h, '-dpng',fullfile(PathName,FileNamePlot) )
end

if save == 0
    subplot(2,2,2);
    hold on;
    box on;
    plot( Ttmp2, tmpdata2, '-', 'LineWidth', 2 );
    plot( Ttmp, tmpdata );
    title('Fig.3: values used for baseline correction');
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
else
    h = figure
    set(h,'Visible','off')
    box on;
    plot( Ttmp2, tmpdata2, '-', 'LineWidth', 2 );
    plot( Ttmp, tmpdata );
    title('Fig.3: values used for baseline correction');
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
    FileNamePlot = strcat( FileName, '-r-polyfit.png' );
    print( h, '-dpng',fullfile(PathName,FileNamePlot) )
end

if save == 0 
    subplot(2,2,3);
    plot( T, normdata )
    title('Fig.2: normalized ratio data');
    hold on
    box on;
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
else
    h = figure
    set(h,'Visible','off')
    box on;
    plot( T, normdata );
    title('Fig.2: normalized ratio data');
    set(gca,'XTick',0:300:3000);
    set(gca,'XTickLabel',{'0','5','10','15','20','25','30','35','40','45','50','55','60'});
    hold on
    %plot( T, normavgdata, 'LineWidth',2 );    
    FileNamePlot = strcat( FileName, '-r-norm.png' );
    print( h, '-dpng',fullfile(PathName,FileNamePlot) )
end

end
     